
--Copyright (c) 1993 Ohio Board of Regents and the University of
--Cincinnati.  All Rights Reserved.

--author: philip a. wilsey
--phil.wilsey@uc.edu


package compose is


--debugging control values passed into places or transitions through
--the generics.  
--  none: no debuging output
--  everything: report all actions
--  trace_mm: trace memory actions in PEs
--  trace_pe: trace actions in the PE units
--  trace_pe_instrs: trace instructions fetched into the PE units
--  trace_opcodes: trace execution of opcodes in the PE units
--  memory_initialization: trace control unit initialization of PE memories
--  control_loop: trace actions in the control unit

type debug is (none, 
               everything,
	       trace_mm,
	       trace_pe,
	       trace_pe_instrs,
	       trace_opcodes,
	       memory_initialization,
	       control_loop);


--some conversion utilities to make life easier

function stringof (in_number : integer) return string;
function stringof (in_bv : bit_vector) return string;
function stringof (in_b : bit) return string;
function stringof (wk_time : time) return string;

function intof (in_bv : bit_vector) return integer;

function bitvectorof (in_number : integer) return bit_vector;


--procedure to write debug line to stdout.

procedure print_debug (name : string;
                       debug_control : debug;
		       message : string);


--generic resolution function for signals with only one driver at any
--time.  

type array_of_bvs is array (positive range <>) of bit_vector (31 downto 0);
function only_one_bv (bv : array_of_bvs) return bit_vector;
subtype register_type is only_one_bv bit_vector (31 downto 0);

type array_of_bs is array (positive range <>) of bit;
function only_one_b (b : array_of_bs) return bit;
subtype resolved_bit is only_one_b bit;
function my_res(b: array_of_bs) return bit;
subtype res_bit is my_res bit;
end compose;
