
--Copyright (c) 1993 Ohio Board of Regents and the University of
--Cincinnati.  All Rights Reserved.


library compose;
use compose.compose.all;
entity main is

end;


architecture demo of main is
signal read_mm : resolved_bit;
signal write_mm :bit;
signal mar : register_type;
signal mdr : register_type;
signal mfc : bit;
signal all_listen : bit;
signal opcode_to_execute : bit;

signal pc_to_mar : bit;
signal increment_pc : bit;
signal mdr_to_ir : bit;

signal s0  :  bit;
signal s1  :  bit;
signal s2  :  bit;
signal s3  :  bit;
signal s4  :  bit;
signal s5  :  bit;
signal s6  :  bit;
signal s7  :  bit;
signal s8  :  bit;

signal memory_initialize : bit;
signal memory_initialized : res_bit; 

component control

    generic (
    	id : string;
    	debug_control : debug);

    port (
	read_mm : out resolved_bit;
        all_listen : out bit;
	opcode_to_execute : out bit;
	
	pc_to_mar : out bit;
	increment_pc : out bit;
	mdr_to_ir : out bit;

	memory_initialize : out bit;
	memory_initialized : in bit;
	
	s0  :  out bit;
	s1  :  out bit;
	s2  :  out bit;
	s3  :  out bit;
	s4  :  out bit;
	s5  :  out bit;
	s6  :  out bit;
	s7  :  out bit;
	s8  :  out bit);

end component;

component box

    generic (
    	id : string ;
	intid : integer;
    	debug_control : debug);
	
    port (
	read_mm : inout resolved_bit;
        all_listen : in bit;
	opcode_to_execute : in bit;
	
	pc_to_mar : in bit;
	increment_pc : in bit;
	mdr_to_ir : in bit;

	memory_initialize : in bit;
	memory_initialized : out bit;
	
	s0  :  in bit;
	s1  :  in bit;
	s2  :  in bit;
	s3  :  in bit;
	s4  :  in bit;
	s5  :  in bit;
	s6  :  in bit;
	s7  :  in bit;
	s8  :  in bit);
    



end component;


for CTL : control use entity compose.control(behavior);
--for B0  : box use entity compose.box(structure);

begin

CTL : control
     generic map ("Control", everything)
     port map (
	read_mm,
        all_listen,
	opcode_to_execute,
	pc_to_mar,
	increment_pc,
	mdr_to_ir,
	memory_initialize,
	memory_initialized,
	s0,
	s1,
	s3,
	s4,
	s5,
	s6,
	s7,
	s8);

GENLABEL: for i in 0 to 0 generate
	B0 : box
	    generic map ("B",i , everything)
	    port map(
		read_mm,
	        all_listen,
		opcode_to_execute,
		pc_to_mar,
		increment_pc,
		mdr_to_ir,
		memory_initialize,
		memory_initialized,
		s0,
		s1,
		s2,
		s3,
		s4,
		s5,
		s6,
		s7,
		s8);
end generate GENLABEL;
    
end;

configuration comp of main is
    for demo
	for all : box
	   use entity compose.box(structure);
	end for;
    end for;
end comp;

